import { Plugin } from 'ckeditor5/src/core';

import SplitAndCreateEditing from './splitandcreateediting';
import SplitAndCreateUI from './splitandcreateui';
import SplitAndCreateCommand from './splitandcreatecommand';

/**
 * @private
 */
export default class SplitAndCreate extends Plugin {

  /**
   * @inheritdoc
   */
  static get requires() {
    return [SplitAndCreateEditing, SplitAndCreateUI];
  }

  afterInit() {

    if (window._layoutParagraphsSplit?.nextStep === 'fill_and_save_duplicate') {
      // Defer to wait until init is complete, to avoid
      // CKEditorError: datacontroller-init-document-not-empty.

      setTimeout(() => {
        // Set value of the new paragraph.
        this.editor.setData(window._layoutParagraphsSplit.end.outerHTML);
        (new SplitAndCreateCommand(this.editor)).getComponentSaveButton().click();
        window._layoutParagraphsSplit.nextStep = 'create_in_between';
        // Next step is handled in the non-CKE Drupal JS library.
      }, 0);

    }
  }

}
