import { Plugin } from 'ckeditor5/src/core';
import { ButtonView } from 'ckeditor5/src/ui';
import icon from '../../../../icons/splitandcreate.svg';

export default class SplitAndCreateUI extends Plugin {
  init() {
    const editor = this.editor;

    editor.ui.componentFactory.add('splitAndCreate', (locale) => {
      const command = editor.commands.get('splitAndCreate');
      const buttonView = new ButtonView(locale);

      // Create the toolbar button.
      buttonView.set({
        label: editor.t('Split and create in-between'),
        icon,
        tooltip: true,
      });

      // Bind the state of the button to the command.
      buttonView.bind('isEnabled').to(command, 'isEnabled');
      buttonView.bind('isVisible').to(command, 'isEnabled');

      // Execute the command when the button is clicked (executed).
      this.listenTo(buttonView, 'execute', () =>
        editor.execute('splitAndCreate'),
      );

      return buttonView;
    });
  }
}
